# include	<stdio.h>
# include	<stdlib.h>
# include	<conio.h>

# include	"vcrplus.h"
# include	"swop.h"

long
scramble4( long top, int d0, long key )
{
	int	d4, d3, d2, d1;
	int	f4, f3, f2, f1;

	/* dismantle 'top' (d0 is already supplied) */
	d4 = ( int ) (top / 1000);
	d3 = ( int )((top / 100) % 10);
	d2 = ( int )((top / 10) % 10);
	d1 = ( int ) (top % 10 );
# ifdef DEBUG
	printf("(%d%d%d%d &", d4, d3, d2, d1);
# endif

	/* dismantle 'key' */
	f4 = ( int ) (key / 1000);
	f3 = ( int )((key / 100) % 10);
	f2 = ( int )((key / 10) % 10);
	f1 = ( int ) (key % 10);
# ifdef DEBUG
	printf("%d%d%d%d) ", f4, f3, f2, f1);
# endif

	do {
		/* long multiply 'f' * 'd' -> 'd' */
		d4 = (d4 + (d3*f1) + (d2*f2) + (d1*f3) + (d0*f4)) % 10 ;
		d3 = (d3 + (d2*f1) + (d1*f2) + (d0*f3)) % 10 ;
		d2 = (d2 + (d1*f1) + (d0*f2)) % 10 ;
		d1 = (d1 + (d0*f1)) % 10 ;

		/* allow ^C */
		if (kbhit()) getch();
/*	} while (d4 == 0);	*/
	} while (0);

	/* reconstruct answer */
	return (1000L*d4) + (100L*d3) + (10L*d2) + d1;
}


int
main( int argc, char *argv[] )
{
	long	val, p1, p2;

	for (val = 1000; val < 1100; val += 8) {
		p1 = scramble4(val, 5, 3445L);
		p1 = permute(p1, 9);
		p1 = scramble4(p1, 8, 4475L);
		printf("%ld -> %ld:\t", val, p1);
		p2 = scramble4(val, 5, 5423L);
		p2 = permute(p2, 22);
		p2 = scramble4(p2, 8, 4759L);
		printf("%ld -> %ld\n", val, p2);
		p1 = scramble4(val+1, 5, 3445L);
		p1 = permute(p1, 9);
		p1 = scramble4(p1, 8, 4475L);
		printf("%ld -> %ld:\t", val+1, p1);
		p2 = scramble4(val+1, 5, 5423L);
		p2 = permute(p2, 22);
		p2 = scramble4(p2, 8, 4759L);
		printf("%ld -> %ld\n", val+1, p2);
	}

	return 0;
}
