# include	<stdio.h>
# include	<stdlib.h>

# include	"vcrplus.h"

# define	KEY001	(68150631L)

/* function that performs initial scrambling */
long
mixup( long x, long y )
{
	long	i, j, k, sum;
	long	a[12], b[12], out[20] ;

	/* get the digits of x into a[] */
	j = x ;
	for(i=0; i<9; i++)
	{
		k = j % 10;
		a[i] = k;
		j = (j - k) / 10 ;
	}

	/* get the digits of y into b[] */
	j = y ;
	for(i=0; i<9; i++)
	{
		k = j % 10;
		b[i] = k;
		j = (j - k) / 10 ;
		out[i] = 0;
	}


	for(i=0; i<=8; i++)
	{
		for(j=0; j<=8; j++)
		{
			out[i+j] += (b[j] * a[i]) ;
		}
	}

	j = 1;
	sum = 0;
	for(i=0; i<=8; i++)
	{
		sum += j * (out[i] % 10);
		j = j * 10 ;
	}
	return( sum ) ;
}

main( int argc, char *argv[] )
{
	int	j;
	long	pwr, atol();

	j = atoi(argv[3]);
	pwr = 1;
	while (j--)
		pwr *= 10;

	printf("%ld\n", mixup(atol(argv[1]), atol(argv[2])) % pwr);
	exit(-1);
}
